#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>

int main(int argc, char *argv[]) {
  if (argc != 2) {
    puts("invocation: ./delayedreaddir <dirpath>");
    return 1;
  }
  DIR *d = opendir(argv[1]);
  if (d == NULL) {
    printf("error: can't open %s - %s\n", argv[1], strerror(errno));
    return 1;
  }
  printf("please press the any key...\n");
  while (getchar() != '\n');
  struct dirent *dent;
  while ((dent = readdir(d)) != NULL) {
    printf("%s ", dent->d_name);
  }
  printf("\n");
}
